﻿using Microsoft.AspNetCore.Mvc;
using System.Transactions;
using UnivateProperties_API.Containers.Timeshare;
using UnivateProperties_API.Repository.Logging;

namespace UnivateProperties_API.Controllers.Logging
{
    [Route("api/[controller]")]
    [ApiController]
    public class SearchLogController : ControllerBase
    {
        private readonly ISearchLogRepository _Repo;

        public SearchLogController(ISearchLogRepository repo)
        {
            _Repo = repo;
        }
      

        [HttpGet]
        public IActionResult Get()
        {      
            return new OkObjectResult(_Repo.GetSearches());
        }
        

        [HttpPost]
        public IActionResult Post([FromBody] SearchObject item)
        {
            using (var scope = new TransactionScope())
            {
                _Repo.SaveSearch(item);
                scope.Complete();
                return new OkObjectResult(item);
            }
        }        
    }
}
