﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Model.Timeshare;

namespace UnivateProperties_API.Model.Campaigns
{
    public class CampaignItem : BaseEntity
    {
        [ForeignKey("Campaign")]
        public int CampaignId { get; set; }
        [ForeignKey("Week")]
        public int WeekId { get; set; }
        public string Image { get; set; }
        
        public virtual TimeshareWeek Week { get; set; }
        public virtual Campaign Campaign { get; set; }

        public virtual ICollection<CampaignItemPlaceHolder> CampaignItemPlaceHolder { get; set; }

        [NotMapped]
        public string WeekUni
        {
            get
            {
                return Week != null ? string.Format("{0} - {1} - {2}", Week.ResortCode, Week.WeekNumber, Week.UnitNumber) : "";
            }
        }
    }
}
