﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace UnivateProperties_API.Model.Communication
{
    public class SMTPAccount : BaseEntity
    {
        #region Constructors
        public SMTPAccount()
        {

        }

        public SMTPAccount(string address)
        {
            Address = address;
        }

        public SMTPAccount(string address, string displayName)
        {
            Address = address;
            DisplayName = displayName;
        }

        public SMTPAccount(string address, string displayName, int smtpHostId)
        {
            Address = address;
            DisplayName = displayName;
            SMTPHostId = smtpHostId;
        }
        #endregion Constructors

        #region Properties
        public string Address { get; set; }
        public string DisplayName { get; set; }
        public bool Default { get; set; }
        [ForeignKey("SMTPHost")]
        public int SMTPHostId { get; set; }

        public virtual SMTPHost SMTPHost { get; set; }
        public virtual ICollection<Email> Emails { get; set; }
        public virtual ICollection<Template> Templates { get; set; }
        #endregion Properties
    }
}
