﻿using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Model.Timeshare;

namespace UnivateProperties_API.Model.ProcessFlow
{
    public class ProcessFlow : BaseEntity
    {
        [ForeignKey("Timeshare")]
        public int? TimeshareID { get; set; }
        [ForeignKey("Property")]
        public int? PropertyID { get; set; }
        [ForeignKey("Status")]
        public int StatusID { get; set; }


        public virtual TimeshareWeek Timeshare { get; set; }
        public virtual Properties.Property Property { get; set; }
        public virtual Status Status { get; set; }

        public override string ToString()
        {
            return $"{(TimeshareID ?? PropertyID).Value} - {Status?.Code}";
        }
    }
}
