﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using UnivateProperties_API.Context;
using UnivateProperties_API.Model.Banks;

namespace UnivateProperties_API.Repository.Banks
{
    public interface IBankRepository
    {
        List<Bank> GetBanks();
    }

    public class BankRepository : IBankRepository
    {
        private readonly DataContext dBContext;

        public BankRepository(DataContext _dBContext)
        {
            dBContext = _dBContext;
        }

        public List<Bank> GetBanks()
        {
            return dBContext.Banks.ToList();
        }
    }
}
