﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using UnivateProperties_API.Context;
using UnivateProperties_API.Model.Communication;

namespace UnivateProperties_API.Repository.Communication
{
    public class EmailRepository : IRepository<Email>
    {
        private readonly DataContext _dbContext;

        public EmailRepository(DataContext dbContext)
        {
            _dbContext = dbContext;
        }

        public List<Email> Get(Func<Email, bool> where)
        {
            return _dbContext.Emails.Where(where).ToList();
        }

        public List<Email> GetAll()
        {
            foreach(var item in _dbContext.Emails.ToList())
            {
                foreach(var innerItem in item.GetAllProperties())
                {
                    var vv = innerItem;
                }
                var v = (string)item["Subject"];
            }
            return _dbContext.Emails.ToList();
        }

        public Email GetDetailed(Func<Email, bool> first)
        {
            var item = _dbContext.Emails.FirstOrDefault(first);
            SMTPAccountRepository account = new SMTPAccountRepository(_dbContext);
            item = GetDetailedObject(item, account);
            return item;
        }

        private Email GetDetailedObject(Email item, SMTPAccountRepository repo)
        {
            item.Sender = repo.GetDetailed(x => x.Id == item.SenderId);
            return item;
        }

        public List<Email> GetDetailedAll()
        {
            var list = GetAll();
            SMTPAccountRepository account = new SMTPAccountRepository(_dbContext);
            foreach (var item in list)
            {
                item.Sender = account.GetDetailed(x => x.Id == item.SenderId);
            }
            return list;
        }

        public void Insert(Email item)
        {
            SMTPAccountRepository account = new SMTPAccountRepository(_dbContext);
            item = GetDetailedObject(item, account);
            item.Id = NewId();
            item.SendMail();
            _dbContext.Add(item);
            Save();
        }

        public void Insert(IEnumerable<Email> items)
        {
            int id = NewId();
            foreach (var item in items)
            {
                item.Id = id;
                item.SendMail();
                _dbContext.Add(item);
                id += 1;
            }
            Save();
        }

        public void Remove(Email item)
        {
            var i = _dbContext.Emails.Find(item);
            _dbContext.Emails.Remove(i);
            Save();
        }

        public void Remove(IEnumerable<Email> items)
        {
            foreach (var item in items)
            {
                Email i = _dbContext.Emails.Find(item);
                _dbContext.Emails.Remove(i);
            }
            Save();
        }

        public void RemoveAtId(int item)
        {
            var i = _dbContext.Emails.Find(item);
            _dbContext.Emails.Remove(i);
            Save();
        }

        public void Update(Email item)
        {
            _dbContext.Entry(item).State = EntityState.Modified;
            Save();
        }

        public void Save()
        {
            _dbContext.SaveChanges();
        }

        public int NewId()
        {
            int id = 0;
            if (_dbContext.Emails.Count() > 0)
            {
                id = _dbContext.Emails.Max(x => x.Id);
            }
            id += 1;
            return id;
        }
    }
}
